<?php
namespace Teknisa\Model\Geral\Repositories;


class Controlsenha extends \Doctrine\ORM\EntityRepository {

    public function getLastPasswordUpdateByCdOperador($cdOperador) {
        $query = <<<SQL
            SELECT TO_CHAR(MAX(DTALTSENHA), 'DD/MM/YYYY') AS DTALTSENHA, IDATUCTRLSENHA
              FROM CONTROLSENHA
             WHERE CDOPERADOR = :CDOPERADOR
               AND DTALTSENHA = (SELECT MAX(DTALTSENHA) AS DTALTSENHA
                                   FROM CONTROLSENHA
                                  WHERE CDOPERADOR = :CDOPERADOR)
             GROUP BY IDATUCTRLSENHA
             ORDER BY DTALTSENHA
SQL;
        $params = array(
            'CDOPERADOR' => $cdOperador
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function getLatestPasswordUpdates($cdOperador, $limit, $entityManager = false) {
        $query = <<<SQL
        SELECT *
          FROM (SELECT CDOPERADOR, DTALTSENHA, CDSENHALTWEB, IDATUCTRLSENHA
                   FROM CONTROLSENHA
                  WHERE CDOPERADOR = :CDOPERADOR
                    AND IDATUCTRLSENHA = 'S'
                    AND CDSENHALTWEB IS NOT NULL
                  ORDER BY DTALTSENHA DESC)
         WHERE ROWNUM <= :LIMIT
SQL;
        $params = array(
            'CDOPERADOR' => $cdOperador,
            'LIMIT'      => $limit
        );

        $entityManager = $entityManager ? $entityManager : $this->getEntityManager();
        return $entityManager->getConnection()->fetchAll($query, $params);
    }
}