describe('gitQueue', function() {
    var currentDirectory = "mar";
    var ZhSocketFactory = {
        create: function(responseHandlerClass) {
            responseHandler = new responseHandlerClass();
            return {
                send: function(sendData) {
                    var sendDataObj = JSON.parse(sendData);
                        responseHandler.response({
                            action: sendDataObj.event,
                            id: sendDataObj.data.id
                        });
                },
				addListener: function() { }
            };
        }
    };
    var GitServerResponse = {

    };
    var ZHPromise = Q;
    var gitQueue = new GitQueue(ZhSocketFactory, ZHPromise, ScreenService);
    gitQueue.connect("localhost");
    var buildMock = function() {
        var mock = {
            whenSuccess: function() {},
            whenError: function() {}
        };
        spyOn(mock, 'whenSuccess').andCallThrough();
        spyOn(mock, 'whenError').andCallThrough();
        return mock;
    };
    beforeEach(function() {

    });
    describe(" GitQueue", function() {
        it('GitQueue cant be undefined', function(done) {
            var processed = false;
            expect(gitQueue).not.toEqual(undefined);
        });
        it('add should call then', function(done) {
            var processed = false;
            var currentDirectory = "";
            var files = [];
            var mock = buildMock();
            var addPromise = gitQueue.add(currentDirectory, files);
            addPromise.then(mock.whenSuccess, mock.whenError).then(function() {
                processed = true;
                expect(mock.whenSuccess).toHaveBeenCalled();
                expect(mock.whenError).not.toHaveBeenCalled();
            });
            waitsFor(function() {
                return processed;
            }, 1000);
        });

        it('add+commit should call then', function(done) {
            var processed = false;
            var currentDirectory = "";
            var files = [];
            var mock = buildMock();
            var addPromise = gitQueue.add(currentDirectory, files);
            var commitPromise = gitQueue.commit(currentDirectory, "Commit teste");
            Q.all([addPromise, commitPromise]).then(mock.whenSuccess, mock.whenError).then(function() {
                processed = true;
                expect(mock.whenSuccess).toHaveBeenCalled();
                expect(mock.whenError).not.toHaveBeenCalled();
            });
            waitsFor(function() {
                return processed;
            }, 1000);
        });
        it('Some commit process should call then!', function() {
            var processed = false;
            var repository = "repo.git";
            var mock = buildMock();
            gitQueue
            .createPath(currentDirectory)
            .clone(currentDirectory, repository)
            .status(currentDirectory)
            .then(mock.whenSuccess, mock.whenError)
            .then(function(){
                processed = true;
                expect(mock.whenSuccess).toHaveBeenCalled();
                expect(mock.whenError).not.toHaveBeenCalled();                
            });
        });
    });
});