CREATE OR REPLACE TRIGGER LOG_DFE_PARAMFORNE
AFTER DELETE OR INSERT OR UPDATE
ON PARAMFORNE FOR EACH ROW
DECLARE
  V_USUARIO	 VARCHAR2(40);
  V_TIPO	 VARCHAR2(1);
  V_ITPESQ	 VARCHAR2(40);
  V_DESC	 VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER	 DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN
      IF :OLD.CDFORNECED IS NOT NULL THEN
         V_DESC := V_DESC || ' Forne=' || :OLD.CDFORNECED;
      END IF;
      IF :OLD.NRDIASBLOQNFFOR IS NOT NULL THEN
         V_DESC := V_DESC || ' NrBloqNFForne=' || :OLD.NRDIASBLOQNFFOR;
      END IF;
      IF :OLD.IDBLQNFRELAFOAF IS NOT NULL THEN
         V_DESC := V_DESC || ' BloqFechNFeRelac=' || :OLD.IDBLQNFRELAFOAF;
      END IF;
      IF :OLD.IDOBRIMPXMLNF IS NOT NULL THEN
         V_DESC := V_DESC || ' ImportXMLNFe=' || :OLD.IDOBRIMPXMLNF;
      END IF;
      IF :OLD.IDOBRCHAVACESFO IS NOT NULL THEN
         V_DESC := V_DESC || ' ObrigChaveNFe=' || :OLD.IDOBRCHAVACESFO;
      END IF;
      IF :OLD.IDVERINSFORCHNFE IS NOT NULL THEN
         V_DESC := V_DESC || ' VerifCNPJChave=' || :OLD.IDVERINSFORCHNFE;
      END IF;
      IF :OLD.IDSIMPLESNACIONAL IS NOT NULL THEN
         V_DESC := V_DESC || ' FornOptSimples=' || :OLD.IDSIMPLESNACIONAL;
      END IF;
      IF :OLD.IMPVENCXML IS NOT NULL THEN
         V_DESC := V_DESC || ' ImpVencXML=' || :OLD.IMPVENCXML;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFORNECED;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFORNECED        <> :NEW.CDFORNECED)        OR
            (:OLD.NRDIASBLOQNFFOR   <> :NEW.NRDIASBLOQNFFOR)   OR
            (:OLD.IDBLQNFRELAFOAF   <> :NEW.IDBLQNFRELAFOAF)   OR
            (:OLD.IDOBRIMPXMLNF     <> :NEW.IDOBRIMPXMLNF)     OR
            (:OLD.IDOBRCHAVACESFO   <> :NEW.IDOBRCHAVACESFO)   OR
            (:OLD.IDVERINSFORCHNFE  <> :NEW.IDVERINSFORCHNFE)  OR
            (:OLD.IDSIMPLESNACIONAL <> :NEW.IDSIMPLESNACIONAL) OR
            (:OLD.IMPVENCXML        <> :NEW.IMPVENCXML) THEN

            V_TIPO     := '2';
            V_ITPESQ   := :OLD.CDFORNECED;
         END IF;
      ELSE
         V_TIPO    := '1';
         V_ITPESQ  := :NEW.CDFORNECED;
      END IF;

      IF :NEW.CDFORNECED IS NOT NULL THEN
         V_DESC := V_DESC || ' Forne=' || :NEW.CDFORNECED;
      END IF;
      IF :NEW.NRDIASBLOQNFFOR IS NOT NULL THEN
         V_DESC := V_DESC || ' NrBloqNFForne=' || :NEW.NRDIASBLOQNFFOR;
      END IF;
      IF :NEW.IDBLQNFRELAFOAF IS NOT NULL THEN
         V_DESC := V_DESC || ' BloqFechNFeRelac=' || :NEW.IDBLQNFRELAFOAF;
      END IF;
      IF :NEW.IDOBRIMPXMLNF IS NOT NULL THEN
         V_DESC := V_DESC || ' ImportXMLNFe=' || :NEW.IDOBRIMPXMLNF;
      END IF;
      IF :NEW.IDOBRCHAVACESFO IS NOT NULL THEN
         V_DESC := V_DESC || ' ObrigChaveNFe=' || :NEW.IDOBRCHAVACESFO;
      END IF;
      IF :NEW.IDVERINSFORCHNFE IS NOT NULL THEN
         V_DESC := V_DESC || ' VerifCNPJChave=' || :NEW.IDVERINSFORCHNFE;
      END IF;
      IF :NEW.IDSIMPLESNACIONAL IS NOT NULL THEN
         V_DESC := V_DESC || ' FornOptSimples=' || :NEW.IDSIMPLESNACIONAL;
      END IF;
      IF :NEW.IMPVENCXML IS NOT NULL THEN
         V_DESC := V_DESC || ' ImpVencXML=' || :NEW.IMPVENCXML;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER)
            VALUES
               ('PARAMFORNE',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC, V_CDFILLOGOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_DFE_PARAMFORNE','5.55.XXX'); END;
/
