<?php
namespace Teknisa\Model\Geral\Repositories;

use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class Estruturah extends \Doctrine\ORM\EntityRepository {
    
    public function retornaEstruturaHistorico($nrorg, $nrestruturam, $dtmescompetenc){

	$params = array('nrestruturam' => $nrestruturam, 'nrorg'=>$nrorg, 'dtmescompetenc' => $dtmescompetenc);
    $estruturah =  '\Teknisa\Model\Geral\Entities\Estruturah';

$sql = <<<SQL
SELECT e FROM $estruturah e
WHERE e.nrorg = :nrorg
    AND e.nrestruturam = :nrestruturam    
    AND e.dtmescompetenc = 
    (SELECT MAX(ee.dtmescompetenc) FROM $estruturah ee
    WHERE ee.nrestruturam = e.nrestruturam
    AND ee.nrorg = e.nrorg
    AND ee.dtmescompetenc <= :dtmescompetenc
    )
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result[0];
    }
    
    public function getFeriados($dtinicio, $dtfinal, $nrestruturam, $dtmescompetencia, $nrorg)
    {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $estruturah =  Repositories::ESTRUTURAH;
        $ocorcalendario = Repositories::OCORCALENDARIO;
        
        $params = [
                    'p_nrorg'=>$nrorg, 
                    'p_nrestruturam' => $nrestruturam, 
                    'p_dtmescompetenc' => $dtmescompetenc,
                  ];     

        $sql = <<<SQL
SELECT DISTINCT OCORCALENDARIO.DTCALENDARIO
FROM ESTRUTURAH
INNER JOIN OCORCALENDARIO
    ON OCORCALENDARIO.NRCALENDARIO = ESTRUTURAH.NRCALENDARIO
    AND OCORCALENDARIO.NRORG = ESTRUTURAH.NRORG
WHERE ESTRUTURAH.NRORG = $nrorg
    AND OCORCALENDARIO.DTCALENDARIO BETWEEN '$dtinicio' AND '$dtfinal'
    AND ESTRUTURAH.NRESTRUTURAM = $nrestruturam
    AND ESTRUTURAH.DTMESCOMPETENC = ( SELECT MAX(MAX_ESTRUTURAH.DTMESCOMPETENC)
                                    FROM ESTRUTURAH MAX_ESTRUTURAH
                                    WHERE MAX_ESTRUTURAH.DTMESCOMPETENC <= '$dtmescompetencia'
                                        AND MAX_ESTRUTURAH.NRORG = ESTRUTURAH.NRORG
                                        AND MAX_ESTRUTURAH.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM)
SQL;
        $result = $db->fetchAll($sql,$params);
        
        if($result)
            return $result;
        else
            return array();
    }    

    
}